/*

The class problem is used as a base class for the derived classes
addproblem, subproblem, multproblem and divproblem.  It would
be unproductive to create an object of type problem, and rather
you should create objects of type addproblem, subproblem, 
multproblem and divproblem instead.

The constructor doesn't assign values to the fractions, instead
it sticks with the values that the fraction class assigns as
default

setleft(fraction):
precondition: instance must be created
postcondition: left operand will be filled and error checked

setright(fraction):
precondition: instance must be created
postcondition: right operand will be filled and error checked

getleft(fraction):
precondition: instance must be created
postcondition: left operand is returned as type fraction
		if not set, this will be a default value from
		the fraction class

getright():
precondition: instance must be created
postcondition: right operand is returned as type fraction
		if not set, this will be a default value from
		the fraction class

getanswer():
precondition: instance must be created
postcondition: answer is returned as type fraction
		if not set or calculated, this will be a
		default value from the fraction class

display();
precondition: instance must be created
postcondition: the entire problem will be displayed via
		the std output in the format:
		a/b ? c/d = e/f
		where a-f are integers and the operator
		is unknown.  This function will be overridden
		in the derived classes

calculate();
precondition: instance must be created
postcondition: the answer to the problem is placed into the
		answer variable.  in this case there is no
		operation to perform.  This function will be
		overridden in the derived classes.

setanswer(fraction):
precondition: instance must be created
postcondition: the answer variable is filled with the fraction
		passed to this function.  This function is 
		protected so it can be used with the derived 
		classes to get access to the answer variable.

*/

#ifndef PROBLEM_H
#define PROBLEM_H


class problem
{

public:

problem();
void setleft(fraction);
void setright(fraction);
fraction getleft();
fraction getright();
fraction getanswer();
void display();
void calculate();

private:

fraction leftop;
fraction rightop;
fraction answer;

protected:
void setanswer(fraction);

};


#endif

#ifndef ADDPROBLEM_H
#define ADDPROBLEM_H
class addproblem : public problem
{
public:

void display();
void calculate();
};
#endif

#ifndef SUBPROBLEM_H
#define SUBPROBLEM_H
class subproblem : public problem
{
public:

void display();
void calculate();
};
#endif

#ifndef MULTPROBLEM_H
#define MULTPROBLEM_H
class multproblem : public problem
{
public:

void display();
void calculate();
};
#endif

#ifndef DIVPROBLEM_H
#define DIVPROBLEM_H
class divproblem : public problem
{
public:

void display();
void calculate();
};
#endif
